<template>
    <div class="barChart">
        <div id="echarts-default-chart"></div>
    </div>


</template>

<script setup lang="ts">
import { onMounted,  watch } from 'vue';
import * as echarts from 'echarts/core';
import { BarChart } from 'echarts/charts';

import {
    TitleComponent,
    TooltipComponent,
    GridComponent,
    LegendComponent,
} from 'echarts/components';
import type { EChartsOption } from 'echarts';

echarts.use([
    TitleComponent,
    TooltipComponent,
    GridComponent,
    LegendComponent,
    BarChart,
]);

const props = defineProps<{
    orientation: string;
    seriesResults: Array<any>;
}>();

let chartDom: HTMLElement | null = null;
let myChart: echarts.ECharts | null = null;


const renderChart = () => {
    try {
        loadDataAndRenderChart(props.seriesResults, props.orientation);
    } catch (error) {
        console.error('Error during chart rendering:', error);
    }
};

watch(props, renderChart, { deep: true });


function loadDataAndRenderChart(results: any, orientation: string): void {

    if (!myChart) {
        chartDom = document.getElementById('echarts-default-chart') as HTMLElement;
        myChart = echarts.init(chartDom);
    }



    const option: EChartsOption = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'shadow',
            },
        },
        legend: {
            left: '2%'

        },
        grid: {
            left: '3%',
            right: '4%',
            bottom: '3%',
            containLabel: true,
        },
        xAxis: orientation === 'x' ? [
            {
                type: 'category',
                data: results[0],
            }
        ] : [
            {
                type: 'value',
            }
        ],
        yAxis: orientation === 'x' ? [
            {
                type: 'value',
            }
        ] : [
            {
                type: 'category',
                data: results[0],
            }
        ],

        series: results[1],
    };

    option && myChart.setOption(option);
}

onMounted(() => {
    try {
        if(myChart)
            renderChart();
    } catch (error) {
        console.error('Error during chart rendering:', error);
    }
});


</script>

<style lang="scss">
@import '@/scss/chart.scss';
</style>
